; 

    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    include \masm32\macros\macros.asm
    
    include macros2.asm

    btodw_small PROTO :DWORD
    btodw_fast PROTO :DWORD

    ;-------------------------------------------
    ; Binary string to unsigned 32 bit integer
    ;-------------------------------------------
    bval_small MACRO lpstring
        invoke btodw_small, reparg(lpstring)
        EXITM <eax>
    ENDM

    bval_fast MACRO lpstring
        invoke btodw_fast, reparg(lpstring)
        EXITM <eax>
    ENDM

; 
    .data
      buffer db "1010101010101010",0
    .code
; 
start:
; 
    print chr$("btodw_small:",13,10)

    print uhex$(bval_small(chr$("0000000000000000")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("0000000000000001")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("0000000000000100")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("0000000010000000")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("0000000010101010")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("0000000011111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("1000000000000000")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("1111111111111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("10000000000000000000000000000000")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("11111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("1111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("11111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_small(chr$("1111111111111111111111111")))
    print chr$(13,10,13,10)

    LOOPCOUNT equ 10000000

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke btodw_small, ADDR buffer
    clockctr_end
    print ustr$(eax)
    print chr$(" clocks",13,10)

    mov eax, input(13,10,"Press enter to continue...",13,10)

    print chr$("btodw_small:",13,10)

    print uhex$(bval_fast(chr$("0000000000000000")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("0000000000000001")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("0000000000000100")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("0000000010000000")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("0000000010101010")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("0000000011111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("1000000000000000")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("1111111111111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("10000000000000000000000000000000")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("11111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("1111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("111111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("11111111111111111111111111111")))
    print chr$(13,10)

    print uhex$(bval_fast(chr$("1111111111111111111111111")))
    print chr$(13,10,13,10)

    LOOPCOUNT equ 10000000

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke btodw_fast, ADDR buffer
    clockctr_end
    print ustr$(eax)
    print chr$(" clocks",13,10)

    mov eax, input(13,10,"Press enter to exit...",13,10)

    exit

;---------------------------------------------------------
; This proc is a reformat of code posted by Petroizki.
;---------------------------------------------------------
btodw_small proc lpstring:DWORD
    mov   edx, lpstring
    xor   eax, eax
  ALIGN 4
  @@:
    movzx ecx, BYTE PTR [edx]
    add   edx, 1
    test  ecx, ecx
    jz    fini
    lea   eax, [eax*2 + ecx - 30h]
    jmp   @B
  fini:
    ret
btodw_small endp

;---------------------------------------------------------
; This proc is a reformat of code posted by Ratch.
;---------------------------------------------------------
btodw_fast proc uses esi lpstring:DWORD
    xor   ecx, ecx
    mov   esi, lpstring
  ALIGN 4
  @@:
    mov   edx, [esi]
    sub   edx, '0000'
    test  edx, 80808080h
    jnz   @F
    mov   eax, 08040201h
    mul   edx
    shl   ecx, 4
    shr   eax, 24
    add   esi, DWORD
    or    ecx, eax
    jmp   @B
  @@:
    movzx edx, BYTE PTR [esi]
    test  edx, edx
    jz    @F
    inc   esi
    lea   ecx, [ecx*2 + edx - '0']
    jmp   @B
  @@:
    mov   eax, ecx
    ret
btodw_fast endp

; 
end start